#include <Rcpp.h>
using namespace Rcpp;

// [[Rcpp::export]]
NumericVector SingleSite(double rho, NumericMatrix WIndices, NumericVector phi, NumericVector D, int V, double tau2, NumericVector Yt, double sig2)  {
  
  float mui;
  float t2i;
  float pm;
  float ps;
  float phii;
  int phiind;
  
  //Loop over the sites
  for(int i=0;i<V;i++){
    //Calculated the mean and variance for site i
    mui = 0;
    for(int j = 0; j < D[i]; j++){
      phiind = WIndices(i,j)-1;
      mui = mui + phi[phiind];
    }
    mui = mui*rho/D[i];
    t2i = tau2/D[i];
    pm = (t2i*Yt[i] + sig2*mui)/(sig2 + t2i);
    ps = sqrt((sig2*t2i)/(sig2 + t2i));
    phii = rnorm(1,pm,ps)[0];
    phi[i] = phii;
  }
  
   return phi;
}

